
active = 1

from App.Management import *
from OFS.DTMLMethod import DTMLMethod

import os

# that this more direct mechanism will be more understandable.
def initialize(context):

	if not active:
		print "Warning!: The ManageInZODB product is not active, please read the README"
		return

	# Manage pages to be used
	manage_pages = ['manage_menu', 'manage_top_frame', 'manage_page_header', 'manage_page_footer', 'manage_form_title', 'manage_copyright', 'manage_zmi_prefs']

	app = context._ProductContext__app

	for page in manage_pages:

	        # Read in the data to put in the method
        	try:
			f = open(os.path.join("lib", "python", "Products", "ManageInZODB", "dtml", page+'.dtml'))
			f = open(os.path.join("lib", "python", "App", "dtml", page+'.dtml'))
		except:
	                # Okay try checking the local directory
	                try:
				f = open(os.path.join("lib", "python", "App", "dtml", page+'.dtml'))
	                except:
				# Couldn't find data, better tell somebody about it
	                        # Couldn't find data! We better pass on this one....
				print "Couldn't find %s, not loading" % page
				print "Tried: %s" % os.path.join("lib", "python", "Products", "ManageInZODB", "dtml", page+'.dtml')
				print "Tried: %s" % os.path.join("lib", "python", "App", "dtml", page+'.dtml')
	                        continue
	
	        # Now we remove the manage page stuff
		exec("del Navigation.%s" % page)

		# Now we add the method to the ZODB
		# Check before creating them!
		if not hasattr(app, page):
			print "%s not in the ZODB creating" % page
			data = f.read()
			doc=DTMLMethod(__name__=page)
			doc.manage_edit(data=data, title='Management interface created by ManageInZODB')
			app._setObject(page, doc, None, None, 0)

	# Check for custom 'manage'
	if os.path.exists(os.path.join("lib", "python", "Products", "ManageInZODB", "override", "manage.dtml")):
		print "Found override for manage, this can be dangerous"
		Navigation.manage = DTMLFile('override/manage', globals())

	try:
		# Special case for manage_tabs
		f = open(os.path.join("lib", "python", "App", "dtml", "manage_tabs.dtml"))
		
		del Tabs.manage_tabs

		if not hasattr(app, 'manage_tabs'):

			data = f.read()
			doc = DTMLMethod(__name__='manage_tabs')
			doc.manage_edit(data=data, title='Management interface created by ManageInZODB')
			app._setObject('manage_tabs', doc, None, None, 0)

	except:
		print "manage_tabs not found."
		
